"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createReadme = void 0;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const hogan = __importStar(require("hogan.js"));
const defaultTemplate_1 = __importDefault(require("./defaultTemplate"));
class ModifiedPackage {
    /**
     *
     * @param {string} packagePath : the package path
     */
    constructor(packagePath) {
        this.package2md = {
            examples: []
        };
        this.modifiers = {
            examples: (pkg) => {
                let ret = [];
                if (pkg.examples && Array.isArray(pkg.examples)) {
                    ret = pkg.examples.map((filePath) => {
                        return fs_1.default.existsSync(filePath) ? fs_1.default.readFileSync(filePath).toString() : null;
                    }).filter(n => n);
                }
                return ret;
            },
            dependencies: (pkg) => {
                return Object.keys(pkg.dependencies || {}).map((key) => {
                    const dependencyPath = path_1.default.resolve(this._path, 'node_modules', key);
                    if (fs_1.default.existsSync(dependencyPath)) {
                        return ModifiedPackage.getPackage(dependencyPath);
                    }
                    return null;
                }).filter(n => n);
            },
            devDependencies: (pkg) => {
                return Object.keys(pkg.devDependencies || {}).map((key) => {
                    const dependencyPath = path_1.default.resolve(this._path, 'node_modules', key);
                    if (fs_1.default.existsSync(dependencyPath)) {
                        return ModifiedPackage.getPackage(dependencyPath);
                    }
                    return null;
                }).filter(n => n);
            },
            repository: (pkg) => {
                if ('string' === typeof pkg.repository) {
                    const arr = pkg.repository.split(/\:\//g, 1);
                    return { type: arr[0], url: arr[1] };
                }
                return pkg.repository;
            }
        };
        console.log('packagePath::::::::', packagePath);
        const t = ModifiedPackage._modules[packagePath] = this;
        t._path = packagePath;
        let pkg;
        try {
            pkg = JSON.parse(fs_1.default.readFileSync(path_1.default.join(packagePath, 'package.json')).toString());
        }
        catch (e) {
            throw new Error(`Unable to parse ${packagePath}: ${e.message}`);
        }
        try {
            pkg = Object.assign({}, pkg, JSON.parse(fs_1.default.readFileSync(path_1.default.join(packagePath, 'package2md.json')).toString()));
        }
        catch (_e) { }
        Object.keys(t.modifiers).forEach(k => {
            pkg[k] = t.modifiers[k](pkg);
        });
        Object.keys(pkg).forEach(k => {
            t[k] = pkg[k];
        });
    }
    static getPackage(packagePath) {
        return ModifiedPackage._modules[packagePath] || new ModifiedPackage(packagePath);
    }
}
ModifiedPackage._modules = {};
function createReadme(packagePath, template = defaultTemplate_1.default) {
    const pkg = ModifiedPackage.getPackage(packagePath);
    console.log(Object.keys(ModifiedPackage._modules));
    fs_1.default.writeFileSync(path_1.default.join(packagePath, 'README.md'), hogan.compile(template).render(pkg));
}
exports.createReadme = createReadme;
